#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int MAXN = int(1e5) + 10;
vector<int> tr_cnt(MAXN * 4);
void build2(int u, int l, int r) {
    if (l == r) {
        tr_cnt[u] = 1;
    }
    else {
        build2(u * 2, l, (l + r) / 2);
        build2(u * 2 + 1, (l + r) / 2 + 1, r);
        tr_cnt[u] = r - l + 1;
    }
}
int get2(int u, int l, int r, int k) {
    if (l == r) {
        return r;
    }
    if (tr_cnt[u * 2] >= k) {
        return get2(u * 2, l, (l + r) / 2, k);
    }
    return get2(u * 2 + 1, (l + r) / 2 + 1, r, k - tr_cnt[u * 2]);
}
void upd2(int u, int l, int r, int i) {
    if (l > i || r < i) {
        return;
    }
    if (l == r) {
        tr_cnt[u] = 0;
        return;
    }
    upd2(u * 2, l, (l + r) / 2, i);
    upd2(u * 2 + 1, (l + r) / 2 + 1, r, i);
    tr_cnt[u] = tr_cnt[u * 2] + tr_cnt[u * 2 + 1];
}
vector<int> tr_mx(MAXN * 4);
vector<int> tr_sum(MAXN * 4);
vector<int> a;
void build(int u, int l, int r) {
    if (l == r) {
        tr_mx[u] = l;
        tr_sum[u] = a[l];
    }
    else {
        build(u * 2, l, (l + r) / 2);
        build(u * 2 + 1, (l + r) / 2 + 1, r);
        tr_sum[u] = tr_sum[u * 2] + tr_sum[u * 2 + 1];
        int i = tr_mx[u * 2], j = tr_mx[u * 2 + 1];
        if (a[i] > a[j]) {
            tr_mx[u] = i;
        }
        else {
            tr_mx[u] = j;
        }
    }
}
int get_sum(int u, int l, int r, int l2, int r2) {
    if (l > r2 || r < l2) {
        return 0;
    }
    if (l <= l2 && r2 <= r) {
        return tr_sum[u];
    }
    return get_sum(u * 2, l, r, l2, (l2 + r2) / 2)
    + get_sum(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2);
}
int get_mx(int u, int l, int r, int l2, int r2) {
    if (l > r2 || r < l2) {
        return -1;
    }
    if (l <= l2 && r2 <= r) {
        return tr_mx[u];
    }
    int i = get_mx(u * 2, l, r, l2, (l2 + r2) / 2);
    int j = get_mx(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2);
    if (i == -1) {
        return j;
    }
    if (j == -1) {
        return i;
    }
    if (a[i] > a[j]) {
        return i;
    }
    else {
        return j;
    }
}
vector<int> tree(MAXN * 4, 0);
vector<int> md(MAXN * 4, -1);
void push(int u, int l, int r) {
    if (md[u] == -1) {
        return;
    }
    tree[u] = md[u] * (r - l + 1);
    if (l != r) {
        md[u * 2] = md[u];
        md[u * 2 + 1] = md[u];
    }
    md[u] = -1;
}
void upd_max(int u, int l, int r, int l2, int r2, int x) {
    push(u, l2, r2);
    if (l > r2 || r < l2) {
        return;
    }
    if (l <= l2 && r2 <= r) {
        md[u] = x;
        push(u, l2, r2);
        return;
    }
    upd_max(u * 2, l, r, l2, (l2 + r2) / 2, x);
    upd_max(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2, x);
    tree[u] = tree[u * 2] + tree[u * 2 + 1];
}
int get_mxsum(int u, int l, int r, int l2, int r2) {
    push(u, l2, r2);
    if (l > r2 || r < l2) {
        return 0;
    }
    if (l <= l2 && r2 <= r) {
        return tree[u];
    }
    return get_mxsum(u * 2, l, r, l2, (l2 + r2) / 2)
    + get_mxsum(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2);
}
void solve() {
    int n;
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    build2(1, 1, n + 1);
    build(1, 1, n);
    vector<int> ans(n, 0);
    vector<pair<int, int>> pref[n + 1];
    vector<pair<int, int>> suf[n + 1];
    for (int q = 1; q <= n - 1; q++) {
        int k;
        cin >> k;
        int beg = get2(1, 1, n + 1, k);
        int j = get2(1, 1, n + 1, k + 1);
        int lst = get2(1, 1, n + 1, k + 2);
        lst--;
        upd2(1, 1, n + 1, j);
        j = get_mx(1, beg, lst, 1, n);
        if (beg != j) {
            ans[q] -= get_sum(1, beg, j - 1, 1, n);
            pref[beg].push_back({j - 1, q});
        }
        if (lst != j) {
            ans[q] -= get_sum(1, j + 1, lst, 1, n);
            suf[lst].push_back({j + 1, q});
        }
        int cur_mx = 0;
        for (int i = lst; i > j; i--) {
            cur_mx = max(cur_mx, a[i]);
            ans[q] += cur_mx;
        }
    }
    vector<pair<int, int>> d(0);
    for (int i = n; i >= 1; i--) {
        while (int(d.size()) > 0 && d.back().second <= a[i]) {
            d.pop_back();
        }
        int beg = n + 1;
        if (int(d.size()) > 0) {
            beg = d.back().first;
        }
        d.push_back({i, a[i]});
        upd_max(1, i, beg - 1, 1, n, a[i]);
        for (auto to : pref[i]) {
            ans[to.second] += get_mxsum(1, i, to.first, 1, n);
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}
int32_t main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}