#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int MAXN = int(1e5) + 10;
vector<int> tr_cnt(MAXN * 4);
void build(int u, int l, int r) {
    if (l == r) {
        tr_cnt[u] = 1;
    }
    else {
        build(u * 2, l, (l + r) / 2);
        build(u * 2 + 1, (l + r) / 2 + 1, r);
        tr_cnt[u] = r - l + 1;
    }
}
int get(int u, int l, int r, int k) {
    if (l == r) {
        return r;
    }
    if (tr_cnt[u * 2] >= k) {
        return get(u * 2, l, (l + r) / 2, k);
    }
    return get(u * 2 + 1, (l + r) / 2 + 1, r, k - tr_cnt[u * 2]);
}
void upd(int u, int l, int r, int i) {
    if (l > i || r < i) {
        return;
    }
    if (l == r) {
        tr_cnt[u] = 0;
        return;
    }
    upd(u * 2, l, (l + r) / 2, i);
    upd(u * 2 + 1, (l + r) / 2 + 1, r, i);
    tr_cnt[u] = tr_cnt[u * 2] + tr_cnt[u * 2 + 1];
}
void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    build(1, 1, n + 1);
    for (int q = 1; q <= n - 1; q++) {
        int k;
        cin >> k;
        int beg = get(1, 1, n + 1, k);
        int j = get(1, 1, n + 1, k + 1);
        int lst = get(1, 1, n + 1, k + 2);
        lst--;
        upd(1, 1, n + 1, j);
        j = -1;
        for (int i = beg; i <= lst; i++) {
            if (j == -1 || a[j] < a[i]) {
                j = i;
            }
        }
        int ans = 0, cur_mx = 0;
        for (int i = beg; i < j; i++) {
            cur_mx = max(cur_mx, a[i]);
            ans += cur_mx - a[i];
        }
        cur_mx = 0;
        for (int i = lst; i > j; i--) {
            cur_mx = max(cur_mx, a[i]);
            ans += cur_mx - a[i];
        }
        cout << ans << '\n';
    }
}
int32_t main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}